import { CanDeactivate } from '@angular/router';
import { Observable } from 'rxjs';
import { TranslateService } from '@ngx-translate/core';
import { ConfirmDialogComponent } from './lumilogin/confirm-dialog/confirm-dialog.component';
import { MatDialogRef, MatDialog } from '@angular/material';
export interface CanComponentDeactivate {
    canDeactivate: () => Observable<boolean> | Promise<boolean> | boolean;
}
export declare class CanDeactivateGuard implements CanDeactivate<CanComponentDeactivate> {
    private translateService;
    private matDialog;
    unsavedChanges: boolean;
    confirmDialogRef: MatDialogRef<ConfirmDialogComponent>;
    constructor(translateService: TranslateService, matDialog: MatDialog);
    setUnsavedChanges(unsavedChanges: boolean): void;
    canDeactivate(): Promise<boolean>;
    askConfirmation(): Promise<boolean>;
}
