import { WebServicesService } from '../web-services/web-services.service';
import { Page } from '../web-services/page.model';
import { PagedData } from '../web-services/paged-data.model';
import { TranslateService } from '@ngx-translate/core';
import { Application } from './application.model';
import { NotificationService } from '../../service/notification/notification.service';
export declare class ApplicationService {
    private notificationService;
    private translateService;
    private webServicesService;
    constructor(notificationService: NotificationService, translateService: TranslateService, webServicesService: WebServicesService);
    getApplications(page?: Page, sort?: string, dir?: string): Promise<PagedData<Application>>;
    postApplication(application: Application): Promise<Application>;
    patchApplication(application: Application): Promise<Application>;
    deleteApplication(applicationId: string): Promise<any>;
}
