import { TranslateService } from '@ngx-translate/core';
import { WebServicesService } from '../web-services/web-services.service';
import { CustomerTree } from './customer-tree.model';
import { NotificationService } from '../../service/notification/notification.service';
export declare class CustomerTreeService {
    private notificationService;
    private translateService;
    private webServicesService;
    constructor(notificationService: NotificationService, translateService: TranslateService, webServicesService: WebServicesService);
    getCustomerTree(): Promise<CustomerTree>;
    getCustomerTreeElement(customerTreeId: number): Promise<CustomerTree>;
    putCustomerTreeElement(name: String, alternateName: string, parentId: number, languages: string, timeZone: string, type: string): Promise<number>;
    patchCustomerTreeElement(id: number, name: string, alternateName: string, parentId: number, languages: string, timeZone: string, type: string): Promise<CustomerTree>;
    deleteCustomerTreeLevel(levelId: number): Promise<any>;
}
