import { WebServicesService } from '../web-services/web-services.service';
import { Page } from '../web-services/page.model';
import { PagedData } from '../web-services/paged-data.model';
import { TranslateService } from '@ngx-translate/core';
import { Role } from './role.model';
import { NotificationService } from '../../service/notification/notification.service';
export declare class RoleService {
    private notificationService;
    private translateService;
    private webServicesService;
    constructor(notificationService: NotificationService, translateService: TranslateService, webServicesService: WebServicesService);
    getRoles(page?: Page, sort?: string, dir?: string): Promise<PagedData<Role>>;
    getRolesForApplication(applicationId: string): Promise<Role[]>;
    postRole(role: Role): Promise<Role>;
    patchRole(role: Role): Promise<Role>;
    deleteRole(role: Role): Promise<any>;
    postRoles(roles: Role[]): Promise<any>;
}
