import { WebServicesService } from '../web-services/web-services.service';
import { Page } from '../web-services/page.model';
import { User } from './user.model';
import { PagedData } from '../web-services/paged-data.model';
import { TranslateService } from '@ngx-translate/core';
import { NotificationService } from '../../service/notification/notification.service';
export declare class UserService {
    private notificationService;
    private translateService;
    private webServicesService;
    constructor(notificationService: NotificationService, translateService: TranslateService, webServicesService: WebServicesService);
    getUsers(page?: Page, sort?: string, dir?: string): Promise<PagedData<User>>;
    postUser(user: User): Promise<User>;
    patchUser(user: User): Promise<User>;
    deleteUser(userId: string): Promise<any>;
}
