import { HttpClient, HttpHeaders } from '@angular/common/http';
import { PagedData } from './paged-data.model';
export declare class WebServicesService {
    private urlApiLumilogin;
    private httpClient;
    constructor(urlApiLumilogin: string, httpClient: HttpClient);
    getList<T>(resourcePath: string): Promise<PagedData<T>>;
    getEntity<T>(resourcePath: string): Promise<T>;
    getBlob(resourcePath: string): Promise<any>;
    post<T>(resourcePath: string, jsonBody: any): Promise<T>;
    put<T>(resourcePath: string, jsonBody: any): Promise<T>;
    postFile(resourcePath: string, file: any): Promise<any>;
    patch<T>(resourcePath: string, jsonBody: any): Promise<T>;
    delete(resourcePath: string): Promise<any>;
    private extractData;
    private extractPagedData;
    private handleError;
    newJsonHeaders(): HttpHeaders;
    newFileHeaders(): HttpHeaders;
}
