import { OnInit, ElementRef } from '@angular/core';
import { KeycloakInstance } from 'keycloak-js';
import { LumiloginService } from '../service/lumilogin.service';
import { TranslationLoaderService } from '../service/translation-loader.service';
import { Subject, Observable } from 'rxjs';
import { NavigationService } from '../navigation/navigation.service';
export declare class HeaderComponent implements OnInit {
    private lumilogin;
    private url;
    private realm;
    private applicationName;
    private show_Search_Bar_All;
    private show_Lang_Selector;
    _translationLoaderService: TranslationLoaderService;
    navigationService: NavigationService;
    readonly LOGO_PATH = "assets/img/logos/";
    lumiloginAuth: KeycloakInstance;
    private static url;
    private static realm;
    applications: any;
    name: any;
    brandedLumi: boolean;
    appNameBasic: any;
    showSearchBarAll: boolean;
    showLangSelector: boolean;
    showSearchBar: boolean;
    searchString: string;
    searchSubject: Subject<string>;
    searchObservable: Observable<string>;
    searchBar: ElementRef;
    logo_img: string;
    constructor(lumilogin: LumiloginService, url: string, realm: string, applicationName: string, show_Search_Bar_All: boolean, show_Lang_Selector: boolean, _translationLoaderService: TranslationLoaderService, navigationService: NavigationService);
    ngOnInit(): void;
    login(): void;
    logout(): void;
    displayUserInfo(): string;
    getCompanyName(): any;
    getAccountUrl(): string;
    initialName(): string;
    isLoggedIn(): boolean;
    displayAppName(name: string): string;
    showAppMenu(): boolean;
    filterApplications(): {
        name: string;
        url: string;
        icon: string;
        logo: string;
    }[];
    setLanguage(lang: any): void;
    onSearchBarChange(): void;
    onClickCloseSearchBar(): void;
    onToggleSearchBarClick(): void;
}
