import { OnInit, EventEmitter } from '@angular/core';
import { CustomerTreeService } from '../api/customer-tree/customer-tree.service';
import { CustomerTree } from '../api/customer-tree/customer-tree.model';
import { CanDeactivateGuard } from '../../../app/can-deactivate.guard';
import { MatSelect } from '@angular/material';
export declare class SubheaderComponent implements OnInit {
    private customerTreeService;
    private canDeactivateGuard;
    readonly SELECT_LEVEL_NAME: string;
    inputLevelId: number;
    selectionChange: EventEmitter<CustomerTree>;
    userHomeLevelId: number;
    customerTree: CustomerTree;
    customerTreeForId: Map<number, CustomerTree>;
    selectedLevel: CustomerTree;
    breadcrumbLevels: CustomerTree[];
    constructor(customerTreeService: CustomerTreeService, canDeactivateGuard: CanDeactivateGuard);
    ngOnInit(): void;
    ngOnChanges(): void;
    prepareCustomerTree(customerTree: CustomerTree): void;
    setSelectedLevel(selectedLevelId: number): void;
    getBreadcrumbLevels(level: CustomerTree, breadcrumbLevels: CustomerTree[]): CustomerTree[];
    getBrothers(level: CustomerTree): CustomerTree[];
    onHomeClick(): void;
    onOpenedChange(matSelect: MatSelect): void;
    onSelectLevel(level: CustomerTree): void;
}
